<?php

class eq3cs_latest_casestudies_widget extends WP_Widget {

  public function __construct() {

	parent::__construct('eq3cs_latest_casestudies_widget', 'Latest Case Studies', array('description' =>
	  'List latest Case Studies'));
  }

  // Code to render options form
  public function form($instance) {

	$widget_title = ( ! empty( $instance['widget_title'] ) ?
		esc_attr( $instance['widget_title'] ) :
		'' );

	$orientation = (!empty($instance['orientation']) ?
		esc_attr($instance['orientation']) :
		'landscape' );
	
	$casestudy_status = (!empty($instance['casestudy_status']) ?
		esc_attr($instance['casestudy_status']) :
		'1' );

	$motion = (!empty($instance['motion']) ?
		esc_attr($instance['motion']) :
		'static' );

	$max_char = (!empty($instance['max-char']) ?
		esc_attr($instance['max-char']) :
		'150' );

	$items_to_show = (!empty($instance['items-to-show']) ?
		esc_attr($instance['items-to-show']) :
		'3' );

	$scroll_speed = (!empty($instance['scroll-speed']) ?
		esc_attr($instance['scroll-speed']) :
		'3000' );
	?>

	<p>
		<label for="
		<?php
		echo esc_attr( $this->get_field_id( 'widget_title' ) );
		?>
	">
		<?php echo esc_attr( 'Widget Title:' ); ?>
			<input type="text"
				id="<?php echo esc_attr( $this->get_field_id( 'widget_title' ) ); ?>"
				name="<?php echo esc_attr( $this->get_field_name( 'widget_title' ) ); ?>"
				value="<?php echo esc_attr( $widget_title ); ?>" />
		</label>
	</p>

	<p><label for="<?php echo $this->get_field_id('casestudy_status');?>">
			   <?php echo 'Case Study Status:'; ?>		
			Published <input type="radio" name="<?php echo $this->get_field_name('casestudy_status'); ?>" 
							id="<?php echo $this->get_field_id('casestudy_status'); ?>" <?php checked($casestudy_status, '1'); ?> value="1">
			Promoted <input type="radio" name="<?php echo $this->get_field_name('casestudy_status'); ?>" 
							 id="<?php echo $this->get_field_id('casestudy_status'); ?>" <?php checked($casestudy_status, '2'); ?> value="2">
		</label>
	</p> 
	<p>
		<label for="<?php echo $this->get_field_id('orientation');
	?>">
				   <?php echo 'Orientation:'; ?>		
			Portrait <input type="radio" name="<?php echo $this->get_field_name('orientation'); ?>" 
							id="<?php echo $this->get_field_id('orientation'); ?>" <?php checked($orientation, 'portrait'); ?> value="portrait">
			Landscape <input type="radio" name="<?php echo $this->get_field_name('orientation'); ?>" 
							 id="<?php echo $this->get_field_id('orientation'); ?>" <?php checked($orientation, 'landscape'); ?> value="landscape">
		</label>
	</p> 

	<p>
		<input class="checkbox" type="checkbox" <?php checked($motion, 'scroll'); ?> 
			   id="<?php echo $this->get_field_id('motion'); ?>" 
			   name="<?php echo $this->get_field_name('motion'); ?>"
			   value="scroll" /> 
		<label for="<?php echo $this->get_field_id('motion'); ?>">Scroll?:</label>
	</p>


	<p>
		<label for="<?php echo $this->get_field_id('max-char');
				   ?>">
				   <?php echo 'Max chars:'; ?>			
			<input type="text" 
				   id="<?php echo $this->get_field_id('max-char'); ?>"
				   name="<?php echo $this->get_field_name('max-char'); ?>"
				   value="<?php echo $max_char; ?>" />			
		</label>
	</p> 

	<p>
		<label for="<?php echo $this->get_field_id('items-to-show');
				   ?>">
				   <?php echo 'Items to Show 1-5:'; ?>			
			<input type="text" 
				   id="<?php echo $this->get_field_id('items-to-show'); ?>"
				   name="<?php echo $this->get_field_name('items-to-show'); ?>"
				   value="<?php echo $items_to_show; ?>" />			
		</label>
	</p> 

	<p>
		<label for="<?php echo $this->get_field_id('scroll-speed');
				   ?>">
				   <?php echo 'Scroll delay 1000-6000:'; ?>			
			<input type="text" 
				   id="<?php echo $this->get_field_id('scroll-speed'); ?>"
				   name="<?php echo $this->get_field_name('scroll-speed'); ?>"
				   value="<?php echo $scroll_speed; ?>" />			
		</label>
	</p> 


	<?php
	wp_reset_query();
  }

  // Function to perform user input validation
  public function update($new_instance, $instance) {

	$instance['widget_title'] = sanitize_text_field( $new_instance['widget_title'] );
	$instance['orientation'] = $new_instance['orientation'];
	$instance['casestudy_status'] = $new_instance['casestudy_status'];

	$instance['motion'] = $new_instance['motion'];

	if (is_numeric($new_instance['max-char']) && $new_instance['max-char'] > 0) {
	  $instance['max-char'] = $new_instance['max-char'];
	}
	else {
	  $instance['max-char'] = 150;
	}

	if (is_numeric($new_instance['items-to-show']) && $new_instance['items-to-show'] > 0 && $new_instance['items-to-show'] < 6) {
	  $instance['items-to-show'] = $new_instance['items-to-show'];
	}
	else {
	  $instance['items-to-show'] = 3;
	}

	if (is_numeric($new_instance['scroll-speed']) && $new_instance['scroll-speed'] >= 1000 && $new_instance['scroll-speed'] <= 6000) {
	  $instance['scroll-speed'] = $new_instance['scroll-speed'];
	}
	else {
	  $instance['scroll-speed'] = 3000;
	}


	return $instance;
  }

  public function widget($args, $instance) {

	require_once EQ3F_PLUGIN_PATH . 'vendor/enquir3/RemstoModuleFunctions.inc';
	//wp_enqueue_style('remsto-casestudy-' . $instance['orientation'] . '-widget');
	wp_enqueue_style('wp-jquery-ui-dialog');
	wp_enqueue_style('eq3f-base-style');
	wp_enqueue_style('eq3f-item-style');
	wp_enqueue_style('eq3f-icon-style');
	wp_enqueue_style('eq3cs-item-style');
	wp_enqueue_style('eq3cs-casestudy-recent-widget');   
	wp_enqueue_style('remsto-casestudy-widget-item');

	wp_enqueue_script('jquery-ui-core');
	wp_enqueue_script('jquery-ui-dialog');
	wp_enqueue_script('eq3f-video-dialog');

	$orientation = $instance['orientation'];
	$items_to_show = $instance['items-to-show'];
	$id = $args['widget_id'];

	if ($instance['motion'] === "scroll") {
	  wp_enqueue_script('eq3f-jquery-jcarousel');
	  wp_enqueue_script('eq3cs-casestudies-scroller');
	  $number_of_items = 10;
	  $options = array(
		'items_to_show' => $items_to_show,
		'orientation' => $orientation,
		'id' => $id,
		'jcarousel' => array(
		  'wrap' => 'circular',
		  'animation' => array(
			'duration' => 900,
			'easing' => 'linear'
		  ),
		),
		'jcarousel_autoscroll' => array(
		  'interval' => $instance['scroll-speed'],
		  'target' => '+=1',
		  'autostart' => true
		)
	  );

	  if ($instance['orientation'] === "portrait") {
		$options['jcarousel']['vertical'] = TRUE;
	  }
	  else {
		$options['jcarousel']['vertical'] = FALSE;
	  }

	  wp_localize_script('eq3cs-casestudies-scroller', 'casestudies_scroller_options', $options);
	  $scroll_target = 'remsto-scroller';
	}
	else {
	  $scroll_target = 'remsto-static';
	  $number_of_items = $instance['items-to-show'];
	}


	$client_options = get_option('enquir3_feedback_options_new', array());
	$rc = new RemstoCaseStudyClient($client_options);

	$pager = array(
	  'items_per_page' => $number_of_items,
	  'page_number' => 0,
	);

	$sort = array(
	  'order' => 'published_date',
	  'sort' => 'DESC',
	);

	$published = array($instance['casestudy_status']);
	if(2 === $instance['casestudy_status']) {
		$published='2';
	}
	else {
		$published='1,2';
	}

	$filter = array(
	  'published' => $published,
	  'randomise' => TRUE,
	);

	$casestudy_data = $rc->listCasestudies($client_options['listing_id'], $filter, $pager, $sort);

	$output = '';
	$output .= "<div class='remsto-casestudy-$orientation-widget'>";
	if ( isset($instance['widget_title']) && '' !== $instance['widget_title'] ) {
		$output .= '<span class="latest-casestudy-title">' . esc_attr( $instance['widget_title'] ) . '</span>';
	}
	$output .= "<div class='casestudy-$orientation-carousel-items casestudy-carousel-items $scroll_target'";
	$output .= " id=$id data-items=$items_to_show >";
	$output .= '<ul>';
		
	foreach ($casestudy_data['case_studies'] as $casestudy) {
	  $case_study = new RemstoCaseStudyItem($casestudy->data);
	  $output .= '<li>';
	  $output .= $this->render_item($case_study, $instance['max-char']);
	  $output .= '</li>';
	}
	
	$output .= '</ul>';
	$output .= '</div></div>';
	// Start scroller
	if ($instance['motion'] === "scroll") {
	  //$output .= $this->init_carousel($options);
	}
	echo $output;
  }

  /**
   * Render item for widget display
   * @param RemstoCaseStudyItem $casestudy
   * @param int $summary_description_char_limit
   * @return string
   */
  private function render_item($casestudy, $summary_description_char_limit) {

	$created_date = date('d/m/Y', $casestudy->published_date);

	$summary = $casestudy->truncateText($casestudy->summary_description, $summary_description_char_limit);
	$id = $casestudy->id;
	//$more_link = "<a class='btn btn-view remsto-btn' href='case-study-article?cid=$id' data-id='$id'>More</a>";
	$more_link = $casestudy->fullPageLink();

	$item_data = array(
	  'title' => sanitize_text_field($casestudy->summary_title),
	  'text' => $summary,
	  #'author' => $author,
	  'anonymous' => $casestudy->anonymous,
	  'first_name' => sanitize_text_field($casestudy->first_name),
	  'last_name' => sanitize_text_field($casestudy->last_name),
	  'town' => sanitize_text_field($casestudy->town),
	  'date' => $created_date,
	  'image_src' => $casestudy->customer_logo_src,
	  'image_alt' => $casestudy->image_alt ? sanitize_text_field($casestudy->image_alt) : '',
	  'more_link' => $more_link,
	);
	
	if ($casestudy->website) {

	  $http = preg_match('/^http[^s]/i', $casestudy->website);
	  if (!$http) {
		$web_link = "http://" . $casestudy->website;
	  }
	  else {
		$web_link =  $casestudy->website;
	  }

	  $item_data['website_link'] = RemstoModuleFunctions::feedback_button(
			  array(
				'id' => '',
				'label' => "<a href='" . $web_link . "' target='_blank' >Visit Website</a>",
				'title' => 'visit website',
				'class' => 'remsto-weblink-btn'
			  )
	  );
	}
	
	if ($casestudy->video_testimonial) {	 
	  $item_data['video_testimonial'] = 
		  RemstoModuleFunctions::processVideoTestimonial($casestudy->id, $casestudy->video_testimonial); 
	}
	
	// Customer logo
	if ($casestudy->customer_logo_src) {
	  $helper = new remstoItemHelper();
	  $item_data['customer_logo'] = $helper->formatImage(
		  array(
			'src' => $casestudy->customer_logo_src,
			'alt' => sanitize_text_field($casestudy->customer_logo_alt),
			'class' => 'tpp-field-logo'
		  )
	  );
	}

	return EQ3F_Feedback::compile_template(
		EQ3CS_PLUGIN_PATH . 'widgets/views/remsto-casestudy-block-item.tpl.php',
		$item_data
	);
  }

  /**
   * Java Script for initialising carousel
   * @param type $options
   */
  private function init_carousel($options) {

	$options_jcarousel = json_encode($options['jcarousel']);
	$options_jcarousel_autoscroll = json_encode($options['jcarousel_autoscroll']);
	$target = $options['target'];
	$fun = "jQuery('$target').jcarousel($options_jcarousel).jcarouselAutoscroll($options_jcarousel_autoscroll)";
	echo '<script type="text/javascript">
			jQuery(document).ready(function() {'
	. $fun .
	'});
		</script>';
  }

}
